`timescale 1ns/1ps

module LIF_Neuron_STDP_tb;

    reg clk;
    reg reset;
    reg [8:0] input_spikes;
    wire spike_out;
    integer i;

    // Instantiate the DUT
    LIF_Neuron_STDP dut (
        .clk(clk),
        .reset(reset),
        .input_spikes(input_spikes),
        .spike_out(spike_out)
    );

    // Clock generation
    always #5 clk = ~clk;

    // Test sequence
    initial begin
        $dumpfile("waveform.vcd");
        $dumpvars(0, LIF_Neuron_STDP_tb);
        for (i = 0; i < 9; i = i + 1)
           $dumpvars(1, dut.weights[i]);
        clk = 0;
        reset = 1;
        input_spikes = 9'b0;

        #10 reset = 0;

        for (i = 0; i < 9; i = i + 1) begin
          // Present target pattern
          input_spikes = 9'b101010101; // Example 3x3 pattern
          #100;

          // Random noise
          input_spikes = 9'b000111000;
          #100;

          // Repeat target pattern
          input_spikes = 9'b101010101;
          #100;
        end

        $finish;
    end
endmodule
